#include <stdlib.h>
#include <stdio.h>
#include <X11/Xos.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xproto.h>
#include <ctype.h>
#include <math.h>
#include <sys/stat.h>

#ifndef PI
#define PI 3.14159265358979323846
#endif
#ifndef NULL
#define NULL ((void *) 0)
#endif
#ifndef MIN
#define MIN(a,b) ( ((a)<(b)) ? (a) : (b) )
#endif
#ifndef MAX
#define MAX(a,b) ( ((a)>(b)) ? (a) : (b) )
#endif
extern void **Calloc2d(int nrows, int ncols, int size);
void Death(int exit_code, char *format_string, ...);
#define Round(a) ((float)(int)(a+((a>0)?.5:-.5)))
int WhichEndian(void);
int LittleEndian(void);
int BigEndian(void);
char *GetTime(void);
int Memset2d(char **data, int init_value, int nr, int nc, int element_size);
int Nswab(char *data, int nelements, int element_size);
void set_sizehints (XSizeHints *hintp, int min_width, int min_height,
		    int defwidth, int defheight, int defx, int defy,
		    char *geom);
int ReadJPEG(FILE *fh, unsigned char ***image, int *image_height, int *image_width);
int ReadGIF(FILE *fh, unsigned char ***image, int *image_height, int *image_width, int *glevels);
int ReadPGM(FILE *fh, unsigned char ***image, int *image_height, int *image_width, int *glevels);
int ReadPPM(FILE *fh, unsigned char ***image, int *image_height, int *image_width, int *image_gamma);
void Usage();
void UsageE();

#define RGB2MONO(rd,gn,bl) (((rd)*11 + (gn)*16 + (bl)*5) >> 5)  /*.33R+ .5G+ .17B*/

#define SCREEN_DUMP_FNAME "zview_dump.pgm"

